All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2014
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compatibility's with Git. In case Git ever changes its licensing terms,
12 # which is admittedly extremely unlikely to the point of being impossible,
13 # this software will most likely follow suit.
15 # This should always be the first line of code to facilitate debugging
16 [ -n "$VCSH_DEBUG" ] && set -vx
19 # If '.git-HEAD' is appended to the version, you are seeing an unreleased
20 # version of vcsh; the master branch is supposed to be clean at all times
21 # so you can most likely just use it nonetheless
26 echo "$SELF: fatal: $1" >&2
31 # We need to run getops as soon as possible so we catch -d and other
32 # options that will modify our behaviour.
33 # Commands are handled at the end of this script.
34 while getopts "c:dv" flag; do
35 if [ x"$1" = x'-d' ] || [ x"$1" = x'--debug' ]; then
40 elif [ x"$1" = x'-v' ]; then
42 echo "verbose mode on"
44 elif [ x"$1" = x'-c' ]; then
45 VCSH_OPTION_CONFIG=$OPTARG
51 # Source file even if it's in $PWD and does not have any slashes in it
59 # Read configuration and set defaults if anything's not set
60 [ -n "$VCSH_DEBUG" ] && set -vx
61 : ${XDG_CONFIG_HOME:="$HOME/.config"}
63 # Read configuration files if there are any
64 [ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
65 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
66 if [ -n "$VCSH_OPTION_CONFIG" ]; then
67 # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
68 if [ -r "$VCSH_OPTION_CONFIG" ]; then
69 source_all "$VCSH_OPTION_CONFIG"
71 fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
74 [ -n "$VCSH_DEBUG" ] && set -vx
77 : ${VCSH_REPO_D:="$XDG_CONFIG_HOME/vcsh/repo.d"}
78 : ${VCSH_HOOK_D:="$XDG_CONFIG_HOME/vcsh/hooks-enabled"}
79 : ${VCSH_OVERLAY_D:="$XDG_CONFIG_HOME/vcsh/overlays-enabled"}
80 : ${VCSH_BASE:="$HOME"}
81 : ${VCSH_GITIGNORE:=exact}
82 : ${VCSH_GITATTRIBUTES:=none}
83 : ${VCSH_WORKTREE:=absolute}
85 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
86 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
89 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ] && [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
90 fatal "'\$VCSH_WORKTREE' must equal 'absolute', or 'relative'" 1
95 echo "usage: $SELF <options> <command>
100 -v Enable verbose mode
104 [<repo>] Clone from an existing repository
105 commit Commit in all repositories
106 delete <repo> Delete an existing repository
107 enter <repo> Enter repository; spawn new instance of \$SHELL
108 help Display this help text
109 init <repo> Initialize a new repository
110 list List all repositories
112 [<repo>] List all files tracked all or one repositories
114 [<-r>] [<repo>] List all files not tracked by all or one repositories
115 pull Pull from all vcsh remotes
116 push Push to vcsh remotes
118 <newname> Rename repository
120 <command> Use this repository
121 status [<repo>] Show statuses of all/one vcsh repositories
122 upgrade <repo> Upgrade repository to currently recommended settings
123 version Print version information
124 which <substring> Find substring in name of any tracked file
126 <repo> Write .gitignore.d/<repo> via git ls-files
128 <repo> <git command> Shortcut to run git commands directly
129 <repo> Shortcut to enter repository" >&2
133 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
137 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
141 echo "$SELF: error: $1" >&2
145 echo "$SELF: info: $1"
151 git remote add origin "$GIT_REMOTE"
152 git config branch.master.remote origin
153 git config branch.master.merge refs/heads/master
154 VCSH_CLONE_ERROR=$(git ls-remote origin master 2>&1)
155 if [ -n "$VCSH_CLONE_ERROR" ]; then
157 fatal "$VCSH_CLONE_ERROR" 1
161 git ls-tree -r --name-only origin/master | (while read object; do
163 error "'$object' exists." &&
166 [ x"$VCSH_CONFLICT" = x'1' ]) &&
167 fatal "will stop after fetching and not try to merge!
168 Once this situation has been resolved, run 'vcsh $VCSH_REPO_NAME pull' to finish cloning." 17
169 git merge origin/master
173 hook post-clone-retired
178 for VCSH_REPO_NAME in $(list); do
179 echo "$VCSH_REPO_NAME: "
180 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
182 git commit --untracked-files=no --quiet
183 VCSH_COMMAND_RETURN_CODE=$?
190 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
192 info "This operation WILL DESTROY DATA!"
193 files=$(git ls-files)
194 echo "These files will be deleted:
198 AGAIN, THIS WILL DELETE YOUR DATA!
199 To continue, type 'Yes, do as I say'"
201 [ "x$answer" = 'xYes, do as I say' ] || exit 16
202 for file in $files; do
203 rm -f $file || info "could not delete '$file', continuing with deletion"
205 rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
216 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
220 for hook in "$VCSH_HOOK_D/$1"* "$VCSH_HOOK_D/$VCSH_REPO_NAME.$1"*; do
221 [ -x "$hook" ] || continue
222 verbose "executing '$hook'"
229 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
230 mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
231 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
232 git init --shared=0600
238 for repo in "$VCSH_REPO_D"/*.git; do
239 [ -d "$repo" ] && [ -r "$repo" ] && echo "$(basename "$repo" .git)"
244 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
249 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
250 if [ -n "$VCSH_REPO_NAME" ]; then
251 get_files | list_tracked_helper
253 for VCSH_REPO_NAME in $(list); do
255 done | list_tracked_helper
259 list_tracked_helper() {
260 sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | sed 's/[,\&]/\\&/g')," | sort -u
268 command -v 'comm' >/dev/null 2>&1 || fatal "Could not find 'comm'"
270 temp_file_others=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
271 temp_file_untracked=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
272 temp_file_untracked_copy=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
274 # Hack in support for `vcsh list-untracked -r`...
275 directory_opt="--directory"
277 while getopts "r" flag; do
278 if [ x"$1" = x'-r' ]; then
283 # ...and parse for a potential parameter afterwards. As we shifted things out of $* in during getops, we need to look at $1
284 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
286 if [ -n "$VCSH_REPO_NAME" ]; then
287 list_untracked_helper $VCSH_REPO_NAME
289 for VCSH_REPO_NAME in $(list); do
290 list_untracked_helper $VCSH_REPO_NAME
293 cat $temp_file_untracked
295 unset directory_opt directory_component
296 rm -f $temp_file_others $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not delete temp files'
299 list_untracked_helper() {
300 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
301 git ls-files --others "$directory_opt" | (
304 directory_component=${line%%/*}
305 [ -d "$directory_component" ] && printf '%s/\n' "$directory_component"
307 ) | sort -u > $temp_file_others
308 if [ -z "$ran_once" ]; then
310 cp $temp_file_others $temp_file_untracked || fatal 'Could not copy temp file'
312 cp $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not copy temp file'
313 comm -12 --nocheck-order $temp_file_others $temp_file_untracked_copy > $temp_file_untracked
318 for VCSH_REPO_NAME in $(list); do
319 printf '%s: ' "$VCSH_REPO_NAME"
320 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
323 VCSH_COMMAND_RETURN_CODE=$?
331 for VCSH_REPO_NAME in $(list); do
332 printf '%s: ' "$VCSH_REPO_NAME"
333 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
336 VCSH_COMMAND_RETURN_CODE=$?
348 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
349 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
351 # Now that the repository has been renamed, we need to fix up its configuration
352 # Overwrite old name..
354 VCSH_REPO_NAME=$VCSH_REPO_NAME_NEW
355 # ..and clobber all old configuration
363 VCSH_COMMAND_RETURN_CODE=$?
368 if [ -n "$VCSH_REPO_NAME" ]; then
369 status_helper $VCSH_REPO_NAME
371 for VCSH_REPO_NAME in $(list); do
372 echo "$VCSH_REPO_NAME:"
373 status_helper $VCSH_REPO_NAME
380 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
382 git status --short --untracked-files='no'
383 VCSH_COMMAND_RETURN_CODE=$?
388 # fake-bare repositories are not bare, actually. Set this to false
389 # because otherwise Git complains "fatal: core.bare and core.worktree
391 git config core.bare false
392 # core.worktree may be absolute or relative to $GIT_DIR, depending on
394 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ]; then
395 git config core.worktree "$(cd "$GIT_DIR" && GIT_WORK_TREE=$VCSH_BASE git rev-parse --show-cdup)"
396 elif [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
397 git config core.worktree "$VCSH_BASE"
399 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
400 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && git config core.attributesfile ".gitattributes.d/$VCSH_REPO_NAME"
401 git config vcsh.vcsh 'true'
403 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
404 [ -e "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME"
410 VCSH_DIRECTORY=$VCSH_REPO_NAME; export VCSH_DIRECTORY
414 [ -e "$VCSH_COMMAND_PARAMETER" ] || fatal "'$VCSH_COMMAND_PARAMETER' does not exist" 1
415 for VCSH_REPO_NAME in $(list); do
416 for VCSH_FILE in $(get_files); do
417 echo "$VCSH_FILE" | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
423 # Don't do anything if the user does not want to write gitignore
424 if [ "x$VCSH_GITIGNORE" = 'xnone' ]; then
425 info "Not writing gitignore as '\$VCSH_GITIGNORE' is set to 'none'"
430 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
433 gitignores=$(for file in $(git ls-files); do
435 echo "$file"; new=${file%/*}
436 [ x"$file" = x"$new" ] && break
441 # Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
442 # Using a template makes GNU mktemp default to $PWD and not #TMPDIR for tempfile location
443 # To make every OS happy, set full path explicitly
444 tempfile=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal "could not create tempfile: '${tempfile}'" 51
446 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
447 for gitignore in $gitignores; do
448 echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
449 if [ "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ -d "$gitignore" ]; then
450 { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
454 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
455 rm -f "$tempfile" || error "could not delete '$tempfile'"
458 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
459 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
460 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
461 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
463 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
464 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
469 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
470 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
473 VCSH_COMMAND=$1; export VCSH_COMMAND
475 case $VCSH_COMMAND in
476 clon|clo|cl) VCSH_COMMAND=clone;;
477 commi|comm|com|co) VCSH_COMMAND=commit;;
478 delet|dele|del|de) VCSH_COMMAND=delete;;
479 ente|ent|en) VCSH_COMMAND=enter;;
480 hel|he) VCSH_COMMAND=help;;
481 ini|in) VCSH_COMMAND=init;;
482 pul) VCSH_COMMAND=pull;;
483 pus) VCSH_COMMAND=push;;
484 renam|rena|ren|re) VCSH_COMMAND=rename;;
485 ru) VCSH_COMMAND=run;;
486 statu|stat|sta|st) VCSH_COMMAND=status;;
487 upgrad|upgra|upgr|up) VCSH_COMMAND=upgrade;;
488 versio|versi|vers|ver|ve) VCSH_COMMAND=version;;
489 which|whi|wh) VCSH_COMMAND=which;;
490 write|writ|wri|wr) VCSH_COMMAND=write-gitignore;;
493 if [ x"$VCSH_COMMAND" = x'clone' ]; then
494 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
496 [ -n "$3" ] && VCSH_REPO_NAME=$3 || VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
497 [ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
498 export VCSH_REPO_NAME
499 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
500 elif [ "$VCSH_COMMAND" = 'version' ]; then
501 echo "$SELF $VERSION"
504 elif [ x"$VCSH_COMMAND" = x'which' ]; then
505 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a filename" 1
506 [ -n "$3" ] && fatal "$VCSH_COMMAND: too many parameters" 1
507 VCSH_COMMAND_PARAMETER=$2; export VCSH_COMMAND_PARAMETER
508 elif [ x"$VCSH_COMMAND" = x'delete' ] ||
509 [ x"$VCSH_COMMAND" = x'enter' ] ||
510 [ x"$VCSH_COMMAND" = x'init' ] ||
511 [ x"$VCSH_COMMAND" = x'list-tracked-by' ] ||
512 [ x"$VCSH_COMMAND" = x'rename' ] ||
513 [ x"$VCSH_COMMAND" = x'run' ] ||
514 [ x"$VCSH_COMMAND" = x'upgrade' ] ||
515 [ x"$VCSH_COMMAND" = x'write-gitignore' ]; then
516 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify repository to work on" 1
517 [ x"$VCSH_COMMAND" = x'rename' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a target name" 1
518 [ x"$VCSH_COMMAND" = x'run' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a command" 1
519 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
520 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
521 [ x"$VCSH_COMMAND" = x'rename' ] && { VCSH_REPO_NAME_NEW=$3; export VCSH_REPO_NAME_NEW;
522 GIT_DIR_NEW=$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git; export GIT_DIR_NEW; }
523 [ x"$VCSH_COMMAND" = x'run' ] && shift 2
524 elif [ x"$VCSH_COMMAND" = x'commit' ] ||
525 [ x"$VCSH_COMMAND" = x'list' ] ||
526 [ x"$VCSH_COMMAND" = x'list-tracked' ] ||
527 [ x"$VCSH_COMMAND" = x'list-untracked' ] ||
528 [ x"$VCSH_COMMAND" = x'pull' ] ||
529 [ x"$VCSH_COMMAND" = x'push' ]; then
531 elif [ x"$VCSH_COMMAND" = x'status' ]; then
532 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
533 elif [ -n "$2" ]; then
534 VCSH_COMMAND='run'; export VCSH_COMMAND
535 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
536 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
537 [ -d "$GIT_DIR" ] || { help; exit 1; }
540 elif [ -n "$VCSH_COMMAND" ]; then
541 VCSH_COMMAND='enter'; export VCSH_COMMAND
542 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
543 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
544 [ -d "$GIT_DIR" ] || { help; exit 1; }
546 # $1 is empty, or 'help'
550 # Did we receive a directory instead of a name?
551 # Mangle the input to fit normal operation.
552 if echo "$VCSH_REPO_NAME" | grep -q '/'; then
553 GIT_DIR=$VCSH_REPO_NAME; export GIT_DIR
554 VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git); export VCSH_REPO_NAME
559 if [ ! -d "$check_directory" ]; then
560 if [ -e "$check_directory" ]; then
561 fatal "'$check_directory' exists but is not a directory" 13
563 verbose "attempting to create '$check_directory'"
564 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
569 check_dir "$VCSH_REPO_D"
570 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
571 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && check_dir "$VCSH_BASE/.gitattributes.d"
573 verbose "$VCSH_COMMAND begin"
574 VCSH_COMMAND=$(echo "$VCSH_COMMAND" | sed 's/-/_/g'); export VCSH_COMMAND
576 # source overlay functions
577 for overlay in "$VCSH_OVERLAY_D/$VCSH_COMMAND"* "$VCSH_OVERLAY_D/$VCSH_REPO_NAME.$VCSH_COMMAND"*; do
578 [ -r "$overlay" ] || continue
579 info "sourcing '$overlay'"
586 verbose "$VCSH_COMMAND end, exiting"
587 exit $VCSH_COMMAND_RETURN_CODE